Skip to content
Snippets Groups Projects
wdep 4.19 KiB
Newer Older
#!/bin/sh
#------------------------------------------------------------------------------
# =========                 |
# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
#  \\    /   O peration     |
#   \\  /    A nd           | Copyright (C) 2014 OpenFOAM Foundation
#    \\/     M anipulation  |
#-------------------------------------------------------------------------------
# License
#     This file is part of OpenFOAM.
#
#     OpenFOAM is free software: you can redistribute it and/or modify it
#     under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#     for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
#
# Script
#     wdep <file>
#     cat `wdep <file>`
#
# Description
#     Find the dep-file corresponding to <file> and print the path.
#
#     Note: wdep MUST be run from the directory containing <file>.
#     If it proves useful an option could be added to search the local
#     source-tree for <file> if it is not in the current directory.
#
#------------------------------------------------------------------------------
Script=${0##*/}

usage() {
    exec 1>&2
    while [ "$#" -ge 1 ]; do echo "$1"; shift; done
    cat<<USAGE

Usage: $Script <file>

Find the dep-file corresponding to <file> in the current directory
and print the path.

USAGE
    exit 1
}


#------------------------------------------------------------------------------
# Parse arguments and options
#------------------------------------------------------------------------------

while [ "$#" -gt 0 ]
do
    case "$1" in
    -h | -help)
        usage
        ;;
    -*)
        usage "unknown option: '$*'"
        ;;
    *)
        break
        ;;
    esac
done


#------------------------------------------------------------------------------
# Check <file> is is the current directory
#------------------------------------------------------------------------------

if [ ! -e $1 ]
then
    echo "$Script error: source file $1 is not in the current directory" 1>&2
    exit 1
fi


#------------------------------------------------------------------------------
# Check environment variables
#------------------------------------------------------------------------------

for envar in WM_OPTIONS WM_DIR WM_PROJECT_DIR
do
    eval test "\$$envar" || {
        echo "$Script error: environment variable \$$envar not set" 1>&2
        exit 1
    }
done


#------------------------------------------------------------------------------
# Search up directories tree for the Make sub-directory
#------------------------------------------------------------------------------

expandPath()
{
    dir=$(dirname $1)
    cwd=$PWD
    cd $dir
    exPath=$PWD
    cd $cwd
}

findTarget()
{
    expandPath $1

    if [ "$exPath" = "$WM_PROJECT_DIR" \
                   -o "$exPath" = "$HOME" \
                   -o "$exPath" = "/" \
       ]
    then
        echo "$Script error: could not find Make directory" 1>&2
        exit 1
    elif [ -d "$1/Make" ]; then
        dir=$1
    else
        findTarget "$1/.."
    fi
}

fileName=${1##*/}

expandPath $1

if echo $exPath | grep "$WM_PROJECT_DIR" > /dev/null
then
    platformPath=$WM_PROJECT_DIR/platforms/${WM_OPTIONS}
    objectsDir=$platformPath$(echo $exPath | sed s%$WM_PROJECT_DIR%% )
else
    path=$exPath
    dir=.
    if [ ! -d Make ]
    then
        findTarget .
    fi
    appDir=$dir
    expandPath $appDir/.
    objectsDir=$appDir/Make/${WM_OPTIONS}$(echo $path | sed s%$exPath%% )
fi

echo $objectsDir/$fileName.dep


#------------------------------------------------------------------------------
# Cleanup local variables and functions
#------------------------------------------------------------------------------

unset Script usage expandPath findTarget


#------------------------------------------------------------------------------